OpenTK
======
 
The Open Toolkit is an advanced, low-level C# library that wraps OpenGL, OpenGL ES and OpenAL. It is suitable for games, scientific applications and any other project that requires 3d graphics, audio or compute functionality.
 
Project website: http://www.opentk.com/
 
Official git repository: https://github.com/opentk/opentk
 
 
Features
========
 
- Create cutting-edge graphics with OpenGL 4.4 and OpenGL ES 3.0
- Spice up your GUI with 3d graphics
- Improve your code flow with strong types and inline documentation
- Write once run everywhere!
 
OpenTK is available on Windows, Linux, Mac OS X, *BSD, SteamOS, Android and iOS. It can be used standalone or integrated into a GUI (Windows.Forms, WPF, GTK+, Qt, VTK, ...)
 
Current Version 1.1 stable released 2014-Feb-10: http://www.opentk.com/news/opentk-1.1-stable-released

Binaries available at http://www.opentk.com

NuGet packages at http://www.nuget.org/packages/OpenTK/
 
Roadmap
=======
 
- Merge opentk/opentk (upstream) with mono/opentk (Xamarin)
- Add Portable Class Library (PCL) target
- Add multitouch API
- Add new platforms: NaCL, emscripten, Windows Metro, Ouya, Raspberry PI
- Improve OpenCL bindings
- Improve math library
 
 
Contributing
============
 
1. Install git and a C# IDE (see requirements section below)
2. Fork the _develop_ branch of https://github.com/opentk/opentk
3. Commit your changes in small, incremental steps with clear descriptions
4. When ready, issue a Pull Request (PR) against the _develop_ branch of https://github.com/opentk/opentk
 
For details on coding style and best practices, refer to https://github.com/opentk/opentk/wiki/Contributing
 
 
Requirements
============
 
- Windows (XP/Vista/7/8), Linux, Mac OS X, *BSD, SteamOS, Android or iOS
- For graphics, OpenGL drivers or a suitable emulator, such as [ANGLE](https://github.com/opentk/opentk/tree/Dependencies/Readme.txt)
- For audio, OpenAL drivers or [OpenAL Soft](https://github.com/opentk/opentk/tree/Dependencies/Readme.txt)
- To develop desktop applications: Visual Studio, Xamarin Studio, MonoDevelop or SharpDevelop
- To develop Android applications: Xamarin Studio or the Xamarin Extensions for Visual Studio
- To develop iOS applications: Xamarin Studio and XCode
 
 
Documentation
=============
 
Your favorite IDE will display inline documentation for all OpenTK APIs. Additional information can be found in the [OpenTK Manual](http://www.opentk.com/doc) and in the [opentk/Documentation/](https://github.com/opentk/opentk/tree/develop/Documentation) folder.
 
Technical documentation about the implementation of OpenTK can be found in the [Technical Wiki](https://github.com/opentk/opentk/wiki).
 
 
Need Help?
==========
 
Post your questions at the [OpenTK forums](http://www.opentk.com/forum).
 
Report bugs at https://github.com/opentk/opentk/issues
 
 
License
=======
 
The Open Toolkit is distributed under the permissive MIT/X11 license and is absolutely free.
 
http://www.opentk.com/project/license
